#!/usr/bin/env python
#!/bin/env python

## Name: report.py
## Version: 1.2.4
## Date: Apr 21, 2016
## Author: Oussema Souiai and Daniel Gautheret
## Maintainer: Oussema Souiai and Van Du Tran
## Description: Report

"""
RNAprof html report: allow displaying regions detected as differentially expressed by RNAprof.
"""

from operator import itemgetter 
import sys
import shutil,os
     
      

def remove_red(liste_gene):
    liste_gene=sorted(liste_gene,key=itemgetter(0),reverse=False)
    i=0
    
    #print liste_gene[1][1]
    
    while i< len(liste_gene)-1:
        if( liste_gene[i][0]==liste_gene[i+1][0] ):
            
            if float(liste_gene[i][1])<=float(liste_gene[i+1][1]):
                liste_gene.remove(liste_gene[i+1])
                i=i
                
            else:
                liste_gene.remove(liste_gene[i])
                i=i
        else:
            i+=1
    return liste_gene           
def write_html_page(directory) :
    fname = directory+"/loci.gff"
    #print "directory",directory
    output_html= os.path.basename(directory)+".html"
    
    file = open(fname, "rb")
    liste_gene=[]
    for line in file:
        ch=line.split("\t")
        if len(ch)==9:
            gene=line[line.find("ID=")+3:line.find("Name")-1]
            if gene.startswith("\""):
                gene=gene[1:]
            if ":"  in gene:
                gene=gene[:gene.find(":")]
            pval1=float((line[line.find("P-adj=")+6:]))
	    score=float((line[line.find("Score=")+6:line.find(";P-val")]))
            deb=ch[3]
            fin=ch[4]
            chrom=ch[0]
            liste_gene.append([gene,pval1,deb,fin,chrom,score])
    liste_gene=remove_red(liste_gene)
    liste_gene=sorted(liste_gene,key=itemgetter(1),reverse=False)

    html_str = """ <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"> 
    <html xmlns="http://www.w3.org/1999/xhtml">
    <link rel="shortcut icon" href="http://d15dxvojnvxp1x.cloudfront.net/assets/favicon.ico">
    <link rel="icon" href="http://d15dxvojnvxp1x.cloudfront.net/assets/favicon.ico">
    <link rel="stylesheet" type="text/css" media="all" href="css/styles.css"> 
    <script type="text/javascript" src="js/jquery-1.10.2.min.js"></script>
    <script type="text/javascript" src="js/jquery.tablesorter.min.js"></script>
    <script src="js/jquery.tablesorter.js"></script>
    <script src="js/jquery.tablesorter.widgets.js"></script>

<script id="js">$(function() {

    var $table = $('table').tablesorter({
        theme: 'blue',
        headers: { 0: { filter: false},3: { filter: false},4: { filter: false},5: { filter: false},6: { filter: false},7: { filter: false} },
        widgets: ["zebra", "filter"],
        widgetOptions : {
            // filter_anyMatch replaced! Instead use the filter_external option
            // Set to use a jQuery selector (or jQuery object) pointing to the
            // external filter (column specific or any match)
            filter_external : '.search',
            // add a default type search to the first name column
            filter_defaultFilter: { 1 : '~{query}' },
            // include column filters
            filter_columnFilters: true,
            
            filter_placeholder: { search : 'Search...' },
            filter_saveFilters : true,
            filter_reset: '.reset'
        }
    });

});</script>
    <body>
    <font size=6> <u><b>RNAprof events summary</b></u></font><br> <br>
    <font size=4>Events are ranked by their ascending significance [adjusted p-values)]. To sort events by other criteria, click on the corresponding column header. For sorting on multiple criteria, shift-click on multiple headers.<br>
     "Profile" links go to the coverage profile figures for corresponding genes.<br>
    To go back to the original display click here: <input type="button" value="Reload Page" onClick="window.location.reload()"> <br><hr>  
    </font>
    <table id="keywords" cellspacing="1" cellpadding="0" border="1">
    <thead>
      <tr>
        <th></th>
        <th>Gene</th>
        <th>Chromosome</th>
        <th>Start</th>
        <th>Stop</th>
        <th>Score</th>
        <th>P-adj</th>
        <th><b>Figure</b></th>
      </tr>
    </thead>
    
    """
    i=0
    while i<len(liste_gene):
        bgcolor=""
        html_str+="<tr class=\"lalign\"><td ></td><td >"+str(liste_gene[i][0])+"</td><td>"+(str(liste_gene[i][4]))+"</td><td>"+str(liste_gene[i][2]) +"</td><td>"+str(liste_gene[i][3]) +"</td><td>"+(str(liste_gene[i][5])) + "</td><td>"+(str(liste_gene[i][1])) +"</td>"+"<td> <a href=%s.html style='display: block'>profile</a></td></td></tr>"%(str(""+liste_gene[i][0]))
        write_html_page2(directory,str(liste_gene[i][0]),".png")
        i+=1
    
    fin_html="""</table>     <script type="text/javascript"> $(function(){   $('#keywords').tablesorter(); }); </script>  </body></html>"""
    html_str+=fin_html
    html_file = open(directory+"/"+output_html,"w")
    html_file.write(html_str)
    html_file.close()    
def write_html_page2(directory, gene,ext) :
    gene_png=gene+ext
    #print gene_png
    #print directory
    gene_html=directory+"/"+gene+".html"
    index= os.path.basename(directory)+".html"
    
    html_str="""<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"> 
     <html xmlns="http://www.w3.org/1999/xhtml">
     
     <head></head>
     <body> <center><a href=%s>back to results</a><br><table style="width:300px" border="1"><iframe src=%s width="2500" height="700" border="0"></iframe></center>"""%(index,gene_png)
    fin_html=""" </tbody></table></body></html>"""
    html_str+=fin_html
    html_file = open(gene_html,"w")
    #print html_str
    html_file.write(html_str)
    html_file.close()
        

if __name__ == "__main__":
    help="""This function creates a HTML result table with links to plots for the significant results and the extension pattern.\n Please provide the RNAprof's path results. By default the generated png files are located in $PREFIX/result/rnaprof_primary_secondary. The resulting table is in the file index.html

    """
    #print sys.argv
    if len(sys.argv) <> 2:
        print(help)

        sys.exit(1)
    else:
        write_html_page(sys.argv[1]) 

